<?php
	// Session aktivieren
	session_start();

   // zustzliche Header, um die Ausgabe nicht zu puffern
   @header ('Expires: Mon, 22 Sep 1997 09:00:00 GMT');
   @header ('Last-Modified: ' . date('r') . ' GMT');
   @header ('Cache-Control: no-store, no-cache, must-revalidate');
   @header ('Cache-Control: post-check=0, pre-check=0', false);
   @header ('Pragma: no-cache');

	// berprfung, ob die Funktionen ImageCreate() vorhanden ist
	if (!function_exists('imagecreate')) {
		@header('Content-Type: image/png');
		readfile('images/error.png');
		exit();
	}

	// Die Galerie ID bernehmen
	$gallerie_id = substr($_GET['gID'],0,16);

	// Erstellung eines Bilds mit den vorgegebenen Ausmaen
	if (empty($_SESSION[$gallerie_id])) {
		$width  = 200;
		$height = 100;
		$wave   = 2;
	} else {
		$width  = (int)$_SESSION[$gallerie_id]['captcha_width'];
		$height = (int)$_SESSION[$gallerie_id]['captcha_height'];
		$size   = (int)($_SESSION[$gallerie_id]['captcha_size']);
		$wave   = (int)($_SESSION[$gallerie_id]['captcha_wave']);
	}
	$grafix		  = ImageCreate($width, $height) or die("Cannot Initialize Captcha");
	$grafix_start = ImageCreate($width, $height);	// for wave effect

   // zufllige Auswahl von Farben fr den Hintergrund und die Inschrift
   mt_srand((double)microtime()*1000000);
	switch (mt_rand(1,6)) {
		case 1:	$settings = array(
						"wallpaper"  => './images/wallpaper1.png',
						"bgColor"    => array(mt_rand(30,100), 0, mt_rand(0,30)),
						"txtColor"   => array(100, mt_rand(20,120), mt_rand(0,60)),
						"noiseColor" => array(200, mt_rand(150, 250), mt_rand(200,210))
					);
					break;
		case 2:	$settings = array(
						"wallpaper"  => './images/wallpaper2.png',
						"bgColor"    => array(230, mt_rand(30,180), 0),
						"txtColor"   => array(mt_rand(200,255), mt_rand(210,255), mt_rand(200,255)),
						"noiseColor" => array(200, mt_rand(100,130), mt_rand(185, 255))
					);
					break;
		case 3:	$settings = array(
						"wallpaper"  => './images/wallpaper3.png',
						"bgColor"    => array(230, mt_rand(30,180), 0),
						"txtColor"   => array(mt_rand(0,50), mt_rand(0,120), mt_rand(0,100)),
						"noiseColor" => array(200, mt_rand(100,130), mt_rand(185, 255))
					);
					break;
		case 4:	$settings = array(
						"wallpaper"  => './images/wallpaper4.png',
						"bgColor"    => array(230, mt_rand(30,180), 0),
						"txtColor"   => array(mt_rand(0,50), mt_rand(0,120), mt_rand(0,100)),
						"noiseColor" => array(200, mt_rand(100,130), mt_rand(185, 255))
					);
					break;
		case 5:	$settings = array(
						"bgColor"    => array(mt_rand(0,100), 0, mt_rand(0,30)),
						"txtColor"   => array(200, mt_rand(100,230), mt_rand(80,155)),
						"noiseColor" => array(mt_rand(150,230), 0, mt_rand(120, 250))
					);
					break;
		case 6:	$settings = array(
						"bgColor"    => array(200, mt_rand(100,230), mt_rand(80,155)),
						"txtColor"   => array(mt_rand(0,100), 0, mt_rand(0,30)),
						"noiseColor" => array(mt_rand(150,230), 0, mt_rand(120, 250))
					);
	}

   // Hintergrundfarbe
   $bgColorRGB = $settings['bgColor'];
   $bgColor    = ImageColorAllocate($grafix, $bgColorRGB[0], $bgColorRGB[1], $bgColorRGB[2]);

   // SET FONT COLOR
   $txtColorRGB = $settings['txtColor'];
   $txtColor    = ImageColorAllocate($grafix, $txtColorRGB[0], $txtColorRGB[1], $txtColorRGB[2]);

   // SET NOISE COLOR
   $noiseColorRGB	= $settings['noiseColor'];
   $noiseColor		= ImageColorAllocate($grafix, $noiseColorRGB[0], $noiseColorRGB[1], $noiseColorRGB[2]);

   // INIT VERIFY TOKEN
   $captchaPhrase = '';

   // DEFINE AVAILABLE CHARS
	$availableChars = "23456789abcdfghjkmnpqrstvwxABCDEFGHJKLMNPRSTUVWXYZ";
	$maxCharsIndex  = strlen($availableChars) - 1;

	// CONCATENATE RANDOM CHARS TO TOKEN
	for ($idx=0; $idx<6; $idx++) {
		$availableChars = str_shuffle($availableChars);
		$captchaPhrase .= $availableChars[mt_rand(0, $maxCharsIndex)];
	}

   // SAVE CAPTCHA PHRASE IN SESSION
   $_SESSION[$gallerie_id]['token'] = sha1($captchaPhrase);

	// TEXT POSITION
   $randSpaceLeft = mt_rand(0, $width-115); // left margin of text for 'imagettftext'
   $randSpaceUp   = mt_rand(30,$height-25); // Grundlinie des Wortes fr 'imagettftext'

	// Schriftartendefinition und zufllige Auswahl einer Schriftart
	if ($fontsList = glob('fonts/*.ttf')) {
		$randFontNo   = mt_rand(0, count($fontsList)-1);
		$randFontPath = realpath($fontsList[$randFontNo]);
	}

   // Fllung des Hintergrunds
	$gd_info = gd_info();
   if (isset($settings['wallpaper']) && $gd_info['FreeType Support'] && $fontsList){
      // das PNG-Bild wird geffnet
      $grafixBackground = @ImageCreateFromPng($settings['wallpaper']);
      // der Inhalt wird auf $grafix kopiert
      ImageCopy($grafix, $grafixBackground, 0, 0, 0, 0, $width, $height);
      ImageCopy($grafix_start, $grafixBackground, 0, 0, 0, 0, $width, $height);	// fr Welleneffekt
   } else {
      ImageFill($grafix, $width, $height, $bgColor);
      ImageFill($grafix_start, $width, $height, $bgColor);								// fr Welleneffekt
   }

   // CREATE TEXT IMAGE
	if ($gd_info['FreeType Support'] && $fontsList)
		//(Grafik, Gre, Rotation, x-, y- Position)
		$text_ok = imagettftext($grafix, $size, mt_rand(-8,8), $randSpaceLeft, $randSpaceUp, $txtColor, $randFontPath, $captchaPhrase);
	else
		//(Grafik, Gre, x-, y- Position)
		$text_ok = imagestring($grafix, 10, $randSpaceLeft, $randSpaceUp-18, $captchaPhrase, $txtColor);

	// WAVE EFFECT
	if ($wave) {
		if		 ($wave === 1) { $cycle = 30; $stauchung = 0.15; }
		elseif ($wave === 2) { $cycle = 50; $stauchung = 0.20; }
		elseif ($wave === 3) { $cycle = 80; $stauchung = 0.30; }
		else { $cycle = $stauchung = 0; }
		$grafix_old = $grafix;
		$grafix		= $grafix_start;
		for ($i=1;$i<=$cycle;$i++){
			imagecopy($grafix, $grafix_old, round((sin($i*$stauchung)*2))+3, $i, 1, $i, $width, $height);
		}
	}

   // Strung des Bildes mit kurzen Strichen
   for($i=1;$i<60;$i++) {
      $randPixSpaceLeft = mt_rand(0, 220);
      $randPixSpaceTop  = mt_rand(0, 100);
      $style = mt_rand(0,2);
      if ($style === 1) {
         ImageLine($grafix, $randPixSpaceLeft, $randPixSpaceTop, $randPixSpaceLeft+10, $randPixSpaceTop+7, $txtColor);
      } elseif($style === 2) {
         ImageLine($grafix, $randPixSpaceLeft, $randPixSpaceTop, $randPixSpaceLeft-3, $randPixSpaceTop+7, $noiseColor);
      } else {
         ImageLine($grafix, $randPixSpaceLeft, $randPixSpaceTop, $randPixSpaceLeft-5, $randPixSpaceTop-5, $bgColor);
      }
   }

	// Abschicken des entsprechenden Headers und des Bildes an den Browser
	header('Content-type: image/png');
	imagepng($grafix);

	// Aufrumen
	imagedestroy($grafix);
?>